diff --git a/gcc/cp/class.c b/gcc/cp/class.c
index 7b10b20..8fe78d0 100644
--- a/gcc/cp/class.c
+++ b/gcc/cp/class.c
@@ -1331,33 +1331,37 @@ check_tag (tree tag, tree id, tree *tp, abi_tag_data *p)
       /* Otherwise we're diagnosing missing tags.  */
       if (TREE_CODE (p->t) == FUNCTION_DECL)
 	{
-	  if (warning (OPT_Wabi_tag, "%qD inherits the %E ABI tag "
-		       "that %qT (used in its return type) has",
-		       p->t, tag, *tp))
-	    inform (location_of (*tp), "%qT declared here", *tp);
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wabi_tag, "%qD inherits the %E ABI tag "
+			 "that %qT (used in its return type) has",
+			 p->t, tag, *tp))
+	    d.inform (location_of (*tp), "%qT declared here", *tp);
 	}
       else if (VAR_P (p->t))
 	{
-	  if (warning (OPT_Wabi_tag, "%qD inherits the %E ABI tag "
-		       "that %qT (used in its type) has", p->t, tag, *tp))
-	    inform (location_of (*tp), "%qT declared here", *tp);
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wabi_tag, "%qD inherits the %E ABI tag "
+			 "that %qT (used in its type) has", p->t, tag, *tp))
+	    d.inform (location_of (*tp), "%qT declared here", *tp);
 	}
       else if (TYPE_P (p->subob))
 	{
-	  if (warning (OPT_Wabi_tag, "%qT does not have the %E ABI tag "
-		       "that base %qT has", p->t, tag, p->subob))
-	    inform (location_of (p->subob), "%qT declared here",
-		    p->subob);
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wabi_tag, "%qT does not have the %E ABI tag "
+			 "that base %qT has", p->t, tag, p->subob))
+	    d.inform (location_of (p->subob), "%qT declared here",
+		      p->subob);
 	}
       else
 	{
-	  if (warning (OPT_Wabi_tag, "%qT does not have the %E ABI tag "
-		       "that %qT (used in the type of %qD) has",
-		       p->t, tag, *tp, p->subob))
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wabi_tag, "%qT does not have the %E ABI tag "
+			 "that %qT (used in the type of %qD) has",
+			 p->t, tag, *tp, p->subob))
 	    {
-	      inform (location_of (p->subob), "%qD declared here",
-		      p->subob);
-	      inform (location_of (*tp), "%qT declared here", *tp);
+	      d.inform (location_of (p->subob), "%qD declared here",
+			p->subob);
+	      d.inform (location_of (*tp), "%qT declared here", *tp);
 	    }
 	}
     }
@@ -2904,20 +2908,24 @@ finish_struct_anon_r (tree field, bool complain)
 	{
 	  /* We already complained about static data members in
 	     finish_static_data_member_decl.  */
-	  if (!VAR_P (elt)
-	      && permerror (DECL_SOURCE_LOCATION (elt),
-			    TREE_CODE (TREE_TYPE (field)) == UNION_TYPE
-			    ? "%q#D invalid; an anonymous union may "
-			    "only have public non-static data members"
-			    : "%q#D invalid; an anonymous struct may "
-			    "only have public non-static data members", elt))
+	  if (!VAR_P (elt))
 	    {
-	      static bool hint;
-	      if (flag_permissive && !hint)
+	      diagnostic_group d;
+	      if (d.permerror (DECL_SOURCE_LOCATION (elt),
+			       TREE_CODE (TREE_TYPE (field)) == UNION_TYPE
+			       ? "%q#D invalid; an anonymous union may "
+			       "only have public non-static data members"
+			       : "%q#D invalid; an anonymous struct may "
+			       "only have public non-static data members", elt))
 		{
-		  hint = true;
-		  inform (DECL_SOURCE_LOCATION (elt),
-			  "this flexibility is deprecated and will be removed");
+		  static bool hint;
+		  if (flag_permissive && !hint)
+		    {
+		      hint = true;
+		      d.inform (DECL_SOURCE_LOCATION (elt),
+				"this flexibility is deprecated and will be "
+				"removed");
+		    }
 		}
 	    }
 	}
@@ -3107,9 +3115,10 @@ one_inherited_ctor (tree ctor, tree t, tree using_decl)
   one_inheriting_sig (t, ctor, new_parms, i);
   if (parms == NULL_TREE)
     {
-      if (warning (OPT_Winherited_variadic_ctor,
-		   "the ellipsis in %qD is not inherited", ctor))
-	inform (DECL_SOURCE_LOCATION (ctor), "%qD declared here", ctor);
+      diagnostic_group d;
+      if (d.warning (OPT_Winherited_variadic_ctor,
+		     "the ellipsis in %qD is not inherited", ctor))
+	d.inform (DECL_SOURCE_LOCATION (ctor), "%qD declared here", ctor);
     }
 }
 
@@ -5399,19 +5408,23 @@ finalize_literal_type_property (tree t)
 	  && !DECL_CONSTRUCTOR_P (fn))
 	{
 	  DECL_DECLARED_CONSTEXPR_P (fn) = false;
-	  if (!DECL_GENERATED_P (fn)
-	      && pedwarn (DECL_SOURCE_LOCATION (fn), OPT_Wpedantic,
-			  "enclosing class of %<constexpr%> non-static member "
-			  "function %q+#D is not a literal type", fn))
-	    explain_non_literal_class (t);
+	  if (!DECL_GENERATED_P (fn))
+	    {
+	      diagnostic_group d;
+	      if (d.pedwarn (DECL_SOURCE_LOCATION (fn), OPT_Wpedantic,
+			     "enclosing class of %<constexpr%> non-static "
+			     "member function %q+#D is not a literal type", fn))
+		explain_non_literal_class (t, &d);
+	    }
 	}
 }
 
 /* T is a non-literal type used in a context which requires a constant
-   expression.  Explain why it isn't literal.  */
+   expression.  Explain why it isn't literal, using D for all
+   diagnostics.  */
 
 void
-explain_non_literal_class (tree t)
+explain_non_literal_class (tree t, diagnostic_group *d)
 {
   static hash_set<tree> *diagnosed;
 
@@ -5425,22 +5438,22 @@ explain_non_literal_class (tree t)
     /* Already explained.  */
     return;
 
-  inform (UNKNOWN_LOCATION, "%q+T is not literal because:", t);
+  d->inform (UNKNOWN_LOCATION, "%q+T is not literal because:", t);
   if (cxx_dialect < cxx17 && LAMBDA_TYPE_P (t))
-    inform (UNKNOWN_LOCATION,
-	    "  %qT is a closure type, which is only literal in "
-	    "C++17 and later", t);
+    d->inform (UNKNOWN_LOCATION,
+	      "  %qT is a closure type, which is only literal in "
+	      "C++17 and later", t);
   else if (TYPE_HAS_NONTRIVIAL_DESTRUCTOR (t))
-    inform (UNKNOWN_LOCATION, "  %q+T has a non-trivial destructor", t);
+    d->inform (UNKNOWN_LOCATION, "  %q+T has a non-trivial destructor", t);
   else if (CLASSTYPE_NON_AGGREGATE (t)
 	   && !TYPE_HAS_TRIVIAL_DFLT (t)
 	   && !LAMBDA_TYPE_P (t)
 	   && !TYPE_HAS_CONSTEXPR_CTOR (t))
     {
-      inform (UNKNOWN_LOCATION,
-	      "  %q+T is not an aggregate, does not have a trivial "
-	      "default constructor, and has no %<constexpr%> constructor that "
-	      "is not a copy or move constructor", t);
+      d->inform (UNKNOWN_LOCATION,
+		 "  %q+T is not an aggregate, does not have a trivial "
+		 "default constructor, and has no %<constexpr%> constructor "
+		 "that is not a copy or move constructor", t);
       if (type_has_non_user_provided_default_constructor (t))
 	/* Note that we can't simply call locate_ctor because when the
 	   constructor is deleted it just returns NULL_TREE.  */
@@ -5454,8 +5467,10 @@ explain_non_literal_class (tree t)
 	    if (sufficient_parms_p (parms))
 	      {
 		if (DECL_DELETED_FN (fn))
+		  // FIXME:
 		  maybe_explain_implicit_delete (fn);
 		else
+		  // FIXME:
 		  explain_invalid_constexpr_fn (fn);
 		break;
 	      }
@@ -5470,10 +5485,10 @@ explain_non_literal_class (tree t)
 	  tree basetype = TREE_TYPE (base_binfo);
 	  if (!CLASSTYPE_LITERAL_P (basetype))
 	    {
-	      inform (UNKNOWN_LOCATION,
-		      "  base class %qT of %q+T is non-literal",
-		      basetype, t);
-	      explain_non_literal_class (basetype);
+	      d->inform (UNKNOWN_LOCATION,
+			 "  base class %qT of %q+T is non-literal",
+			 basetype, t);
+	      explain_non_literal_class (basetype, d);
 	      return;
 	    }
 	}
@@ -5485,15 +5500,15 @@ explain_non_literal_class (tree t)
 	  ftype = TREE_TYPE (field);
 	  if (!literal_type_p (ftype))
 	    {
-	      inform (DECL_SOURCE_LOCATION (field),
-		      "  non-static data member %qD has non-literal type",
-		      field);
+	      d->inform (DECL_SOURCE_LOCATION (field),
+			 "  non-static data member %qD has non-literal type",
+			 field);
 	      if (CLASS_TYPE_P (ftype))
-		explain_non_literal_class (ftype);
+		explain_non_literal_class (ftype, d);
 	    }
 	  if (CP_TYPE_VOLATILE_P (ftype))
-	    inform (DECL_SOURCE_LOCATION (field),
-		    "  non-static data member %qD has volatile type", field);
+	    d->inform (DECL_SOURCE_LOCATION (field),
+		       "  non-static data member %qD has volatile type", field);
 	}
     }
 }
@@ -6626,17 +6641,20 @@ find_flexarrays (tree t, flexmems_t *fmem, bool base_p,
 static void
 diagnose_invalid_flexarray (const flexmems_t *fmem)
 {
-  if (fmem->array && fmem->enclosing
-      && pedwarn (location_of (fmem->enclosing), OPT_Wpedantic,
-		  TYPE_DOMAIN (TREE_TYPE (fmem->array))
-		  ? G_("invalid use of %q#T with a zero-size array "
-		       "in %q#D")
-		  : G_("invalid use of %q#T with a flexible array member "
-		       "in %q#T"),
-		  DECL_CONTEXT (fmem->array),
-		  DECL_CONTEXT (fmem->enclosing)))
-    inform (DECL_SOURCE_LOCATION (fmem->array),
-	    "array member %q#D declared here", fmem->array);
+  if (fmem->array && fmem->enclosing)
+    {
+      diagnostic_group d;
+      if (d.pedwarn (location_of (fmem->enclosing), OPT_Wpedantic,
+		     TYPE_DOMAIN (TREE_TYPE (fmem->array))
+		     ? G_("invalid use of %q#T with a zero-size array "
+			  "in %q#D")
+		     : G_("invalid use of %q#T with a flexible array member "
+			  "in %q#T"),
+		     DECL_CONTEXT (fmem->array),
+		     DECL_CONTEXT (fmem->enclosing)))
+	d.inform (DECL_SOURCE_LOCATION (fmem->array),
+		  "array member %q#D declared here", fmem->array);
+    }
 }
 
 /* Issue diagnostics for invalid flexible array members or zero-length
@@ -6670,10 +6688,10 @@ diagnose_flexarrays (tree t, const flexmems_t *fmem)
       if (msg)
 	{
 	  location_t loc = DECL_SOURCE_LOCATION (fmem->array);
-
-	  if (pedwarn (loc, OPT_Wpedantic, msg, fmem->array, t))
+	  diagnostic_group d;
+	  if (d.pedwarn (loc, OPT_Wpedantic, msg, fmem->array, t))
 	    {
-	      inform (location_of (t), "in the definition of %q#T", t);
+	      d.inform (location_of (t), "in the definition of %q#T", t);
 	      diagd = true;
 	    }
 	}
@@ -6690,7 +6708,8 @@ diagnose_flexarrays (tree t, const flexmems_t *fmem)
 	  location_t loc = DECL_SOURCE_LOCATION (fmem->array);
 	  diagd = true;
 
-	  error_at (loc, msg, fmem->array, t);
+	  diagnostic_group d;
+	  d.error_at (loc, msg, fmem->array, t);
 
 	  /* In the unlikely event that the member following the flexible
 	     array member is declared in a different class, or the member
@@ -6700,10 +6719,10 @@ diagnose_flexarrays (tree t, const flexmems_t *fmem)
 	      && ((DECL_CONTEXT (fmem->after[0])
 		   != DECL_CONTEXT (fmem->array))))
 	    {
-	      inform (DECL_SOURCE_LOCATION (fmem->after[0]),
-		      "next member %q#D declared here",
-		      fmem->after[0]);
-	      inform (location_of (t), "in the definition of %q#T", t);
+	      d.inform (DECL_SOURCE_LOCATION (fmem->after[0]),
+			"next member %q#D declared here",
+			fmem->after[0]);
+	      d.inform (location_of (t), "in the definition of %q#T", t);
 	    }
 	}
     }
@@ -7923,11 +7942,12 @@ resolve_address_of_overloaded_function (tree target_type,
       if (!(complain & tf_error))
 	return error_mark_node;
 
-      if (permerror (input_location, "assuming pointer to member %qD", fn)
+      diagnostic_group d;
+      if (d.permerror (input_location, "assuming pointer to member %qD", fn)
 	  && !explained)
 	{
-	  inform (input_location, "(a pointer to member can only be "
-		  "formed with %<&%E%>)", fn);
+	  d.inform (input_location, "(a pointer to member can only be "
+		    "formed with %<&%E%>)", fn);
 	  explained = 1;
 	}
     }
diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index ece2c8a..2bf8d0c 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -97,18 +97,20 @@ ensure_literal_type_for_constexpr_object (tree decl)
 	{
 	  if (DECL_DECLARED_CONSTEXPR_P (decl))
 	    {
-	      error ("the type %qT of %<constexpr%> variable %qD "
-		     "is not literal", type, decl);
-	      explain_non_literal_class (type);
+	      diagnostic_group d;
+	      d.error ("the type %qT of %<constexpr%> variable %qD "
+		       "is not literal", type, decl);
+	      explain_non_literal_class (type, &d);
 	      decl = error_mark_node;
 	    }
 	  else
 	    {
 	      if (!is_instantiation_of_constexpr (current_function_decl))
 		{
-		  error ("variable %qD of non-literal type %qT in %<constexpr%> "
-			 "function", decl, type);
-		  explain_non_literal_class (type);
+		  diagnostic_group d;
+		  d.error ("variable %qD of non-literal type %qT in "
+			   "%<constexpr%> function", decl, type);
+		  explain_non_literal_class (type, &d);
 		  decl = error_mark_node;
 		}
 	      cp_function_chain->invalid_constexpr = true;
@@ -200,9 +202,10 @@ is_valid_constexpr_fn (tree fun, bool complain)
 	    ret = false;
 	    if (complain)
 	      {
-		error ("invalid type for parameter %d of %<constexpr%> "
-		       "function %q+#D", DECL_PARM_INDEX (parm), fun);
-		explain_non_literal_class (TREE_TYPE (parm));
+		diagnostic_group d;
+		d.error ("invalid type for parameter %d of %<constexpr%> "
+			 "function %q+#D", DECL_PARM_INDEX (parm), fun);
+		explain_non_literal_class (TREE_TYPE (parm), &d);
 	      }
 	  }
     }
@@ -222,9 +225,10 @@ is_valid_constexpr_fn (tree fun, bool complain)
 	  ret = false;
 	  if (complain)
 	    {
-	      error ("invalid return type %qT of %<constexpr%> function %q+D",
-		     rettype, fun);
-	      explain_non_literal_class (rettype);
+	      diagnostic_group d;
+	      d.error ("invalid return type %qT of %<constexpr%> function %q+D",
+		       rettype, fun);
+	      explain_non_literal_class (rettype, &d);
 	    }
 	}
 
@@ -234,11 +238,15 @@ is_valid_constexpr_fn (tree fun, bool complain)
 	  && !CLASSTYPE_LITERAL_P (DECL_CONTEXT (fun)))
 	{
 	  ret = false;
-	  if (complain
-	      && pedwarn (DECL_SOURCE_LOCATION (fun), OPT_Wpedantic,
-			  "enclosing class of %<constexpr%> non-static member "
-			  "function %q+#D is not a literal type", fun))
-	    explain_non_literal_class (DECL_CONTEXT (fun));
+	  if (complain)
+	    {
+	      diagnostic_group d;
+	      if (d.pedwarn (DECL_SOURCE_LOCATION (fun), OPT_Wpedantic,
+			     "enclosing class of %<constexpr%> non-static"
+			     " member function %q+#D is not a literal type",
+			     fun))
+		explain_non_literal_class (DECL_CONTEXT (fun), &d);
+	    }
 	}
     }
   else if (CLASSTYPE_VBASECLASSES (DECL_CONTEXT (fun)))
@@ -818,9 +826,10 @@ cx_check_missing_mem_inits (tree ctype, tree body, bool complain)
 	    }
 	  if (!complain)
 	    return true;
-	  error ("member %qD must be initialized by mem-initializer "
-		 "in %<constexpr%> constructor", field);
-	  inform (DECL_SOURCE_LOCATION (field), "declared here");
+	  diagnostic_group d;
+	  d.error ("member %qD must be initialized by mem-initializer "
+		   "in %<constexpr%> constructor", field);
+	  d.inform (DECL_SOURCE_LOCATION (field), "declared here");
 	  bad = true;
 	}
       if (field == NULL_TREE)
@@ -4303,9 +4312,10 @@ cxx_eval_constant_expression (const constexpr_ctx *ctx, tree t,
 	{
 	  if (!ctx->quiet)
 	    {
-	      error ("temporary of non-literal type %qT in a "
-		     "constant expression", TREE_TYPE (t));
-	      explain_non_literal_class (TREE_TYPE (t));
+	      diagnostic_group d;
+	      d.error ("temporary of non-literal type %qT in a "
+		       "constant expression", TREE_TYPE (t));
+	      explain_non_literal_class (TREE_TYPE (t), &d);
 	    }
 	  *non_constant_p = true;
 	  break;
@@ -5995,9 +6005,10 @@ potential_constant_expression_1 (tree t, bool want_rval, bool strict, bool now,
 	{
 	  if (flags & tf_error)
 	    {
+	      diagnostic_group d;
 	      error_at (loc, "temporary of non-literal type %qT in a "
 			"constant expression", TREE_TYPE (t));
-	      explain_non_literal_class (TREE_TYPE (t));
+	      explain_non_literal_class (TREE_TYPE (t), &d);
 	    }
 	  return false;
 	}
diff --git a/gcc/cp/constraint.cc b/gcc/cp/constraint.cc
index 9f9fb52..265d731 100644
--- a/gcc/cp/constraint.cc
+++ b/gcc/cp/constraint.cc
@@ -3128,10 +3128,12 @@ diagnose_declaration_constraints (location_t loc, tree decl, tree args)
    or a declaration.  */
 
 void
-diagnose_constraints (location_t loc, tree t, tree args)
+diagnose_constraints (diagnostic_group *group, location_t loc, tree t,
+		      tree args)
 {
   constraint_errors = 0;
 
+  // FIXME: use group:
   if (constraint_p (t))
     diagnose_constraint (loc, t, t, args);
   else if (DECL_P (t))
@@ -3142,5 +3144,5 @@ diagnose_constraints (location_t loc, tree t, tree args)
   /* Note the number of elided failures. */
   int n = undiagnosed_constraint_failures ();
   if (n > 0)
-    inform (loc, "... and %d more constraint errors not shown", n);
+    group->inform (loc, "... and %d more constraint errors not shown", n);
 }
diff --git a/gcc/cp/cp-gimplify.c b/gcc/cp/cp-gimplify.c
index 7db4acc..13b2418 100644
--- a/gcc/cp/cp-gimplify.c
+++ b/gcc/cp/cp-gimplify.c
@@ -1420,12 +1420,15 @@ cp_genericize_r (tree *stmt_p, int *walk_subtrees, void *data)
 	  /* Never mind.  */;
 	else if (wtd->try_block)
 	  {
-	    if (TREE_CODE (wtd->try_block) == MUST_NOT_THROW_EXPR
-		&& warning_at (loc, OPT_Wterminate,
-			       "throw will always call terminate()")
-		&& cxx_dialect >= cxx11
-		&& DECL_DESTRUCTOR_P (current_function_decl))
-	      inform (loc, "in C++11 destructors default to noexcept");
+	    if (TREE_CODE (wtd->try_block) == MUST_NOT_THROW_EXPR)
+	      {
+		diagnostic_group d;
+		if (d.warning_at (loc, OPT_Wterminate,
+				  "throw will always call terminate()")
+		    && cxx_dialect >= cxx11
+		    && DECL_DESTRUCTOR_P (current_function_decl))
+		  d.inform (loc, "in C++11 destructors default to noexcept");
+	      }
 	  }
 	else
 	  {
diff --git a/gcc/cp/cp-tree.h b/gcc/cp/cp-tree.h
index aba246c..faaa766 100644
--- a/gcc/cp/cp-tree.h
+++ b/gcc/cp/cp-tree.h
@@ -6217,7 +6217,7 @@ extern bool classtype_has_non_deleted_move_ctor (tree);
 extern tree classtype_has_user_copy_or_dtor	(tree);
 extern bool type_build_ctor_call		(tree);
 extern bool type_build_dtor_call		(tree);
-extern void explain_non_literal_class		(tree);
+extern void explain_non_literal_class		(tree, diagnostic_group *);
 extern void inherit_targ_abi_tags		(tree);
 extern void defaulted_late_check		(tree);
 extern bool defaultable_fn_check		(tree);
@@ -7469,8 +7469,10 @@ extern tree cp_fully_fold			(tree);
 extern void clear_fold_cache			(void);
 
 /* in name-lookup.c */
-extern void suggest_alternatives_for            (location_t, tree, bool);
-extern bool suggest_alternative_in_explicit_scope (location_t, tree, tree);
+extern void suggest_alternatives_for            (diagnostic_group *,
+						 location_t, tree, bool);
+extern bool suggest_alternative_in_explicit_scope (diagnostic_group *,
+						   location_t, tree, tree);
 extern tree strip_using_decl                    (tree);
 
 /* Tell the binding oracle what kind of binding we are looking for.  */
@@ -7551,7 +7553,8 @@ extern bool subsumes_constraints                (tree, tree);
 extern bool strictly_subsumes			(tree, tree);
 extern int more_constrained                     (tree, tree);
 
-extern void diagnose_constraints                (location_t, tree, tree);
+extern void diagnose_constraints                (diagnostic_group *, location_t,
+						 tree, tree);
 
 /* in logic.cc */
 extern tree decompose_conclusions               (tree);
diff --git a/gcc/cp/cvt.c b/gcc/cp/cvt.c
index da98414..ef9fbaddc 100644
--- a/gcc/cp/cvt.c
+++ b/gcc/cp/cvt.c
@@ -1017,23 +1017,25 @@ maybe_warn_nodiscard (tree expr, impl_conv_void implicit)
   if (implicit != ICV_CAST && fn
       && lookup_attribute ("nodiscard", DECL_ATTRIBUTES (fn)))
     {
-      if (warning_at (loc, OPT_Wunused_result,
-		      "ignoring return value of %qD, "
-		      "declared with attribute nodiscard", fn))
-	inform (DECL_SOURCE_LOCATION (fn), "declared here");
+      diagnostic_group d;
+      if (d.warning_at (loc, OPT_Wunused_result,
+			"ignoring return value of %qD, "
+			"declared with attribute nodiscard", fn))
+	d.inform (DECL_SOURCE_LOCATION (fn), "declared here");
     }
   else if (implicit != ICV_CAST
 	   && lookup_attribute ("nodiscard", TYPE_ATTRIBUTES (rettype)))
     {
-      if (warning_at (loc, OPT_Wunused_result,
-		      "ignoring returned value of type %qT, "
-		      "declared with attribute nodiscard", rettype))
+      diagnostic_group d;
+      if (d.warning_at (loc, OPT_Wunused_result,
+			"ignoring returned value of type %qT, "
+			"declared with attribute nodiscard", rettype))
 	{
 	  if (fn)
-	    inform (DECL_SOURCE_LOCATION (fn),
-		    "in call to %qD, declared here", fn);
-	  inform (DECL_SOURCE_LOCATION (TYPE_NAME (rettype)),
-		  "%qT declared here", rettype);
+	    d.inform (DECL_SOURCE_LOCATION (fn),
+		      "in call to %qD, declared here", fn);
+	  d.inform (DECL_SOURCE_LOCATION (TYPE_NAME (rettype)),
+		    "%qT declared here", rettype);
 	}
     }
   else if (TREE_CODE (expr) == TARGET_EXPR
@@ -1043,11 +1045,12 @@ maybe_warn_nodiscard (tree expr, impl_conv_void implicit)
 	 result is used, so handle that case here.  */
       if (fn)
 	{
-	  if (warning_at (loc, OPT_Wunused_result,
-			  "ignoring return value of %qD, "
-			  "declared with attribute warn_unused_result",
-			  fn))
-	    inform (DECL_SOURCE_LOCATION (fn), "declared here");
+	  diagnostic_group d;
+	  if (d.warning_at (loc, OPT_Wunused_result,
+			    "ignoring return value of %qD, "
+			    "declared with attribute warn_unused_result",
+			    fn))
+	    d.inform (DECL_SOURCE_LOCATION (fn), "declared here");
 	}
       else
 	warning_at (loc, OPT_Wunused_result,
diff --git a/gcc/cp/decl.c b/gcc/cp/decl.c
index 78ebbde..0175ea9 100644
--- a/gcc/cp/decl.c
+++ b/gcc/cp/decl.c
@@ -1133,10 +1133,11 @@ warn_extern_redeclared_static (tree newdecl, tree olddecl)
       && DECL_ARTIFICIAL (olddecl))
     return;
 
-  if (permerror (DECL_SOURCE_LOCATION (newdecl),
-		 "%qD was declared %<extern%> and later %<static%>", newdecl))
-    inform (DECL_SOURCE_LOCATION (olddecl),
-	    "previous declaration of %qD", olddecl);
+  diagnostic_group d;
+  if (d.permerror (DECL_SOURCE_LOCATION (newdecl),
+		   "%qD was declared %<extern%> and later %<static%>", newdecl))
+    d.inform (DECL_SOURCE_LOCATION (olddecl),
+	      "previous declaration of %qD", olddecl);
 }
 
 /* NEW_DECL is a redeclaration of OLD_DECL; both are functions or
@@ -1176,17 +1177,18 @@ check_redeclaration_exception_specification (tree new_decl,
 	= G_("declaration of %qF has a different exception specifier");
       bool complained = true;
       location_t new_loc = DECL_SOURCE_LOCATION (new_decl);
+      diagnostic_group d;
       if (DECL_IN_SYSTEM_HEADER (old_decl))
-	complained = pedwarn (new_loc, OPT_Wsystem_headers, msg, new_decl);
+	complained = d.pedwarn (new_loc, OPT_Wsystem_headers, msg, new_decl);
       else if (!flag_exceptions)
 	/* We used to silently permit mismatched eh specs with
 	   -fno-exceptions, so make them a pedwarn now.  */
-	complained = pedwarn (new_loc, OPT_Wpedantic, msg, new_decl);
+	complained = d.pedwarn (new_loc, OPT_Wpedantic, msg, new_decl);
       else
-	error_at (new_loc, msg, new_decl);
+	d.error_at (new_loc, msg, new_decl);
       if (complained)
-	inform (DECL_SOURCE_LOCATION (old_decl),
-		"from previous declaration %qF", old_decl);
+	d.inform (DECL_SOURCE_LOCATION (old_decl),
+		  "from previous declaration %qF", old_decl);
     }
 }
 
@@ -1304,11 +1306,12 @@ check_no_redeclaration_friend_default_args (tree olddecl, tree newdecl,
     if ((olddecl_hidden_friend_p && TREE_PURPOSE (t1))
 	|| (DECL_FRIEND_P (newdecl) && TREE_PURPOSE (t2)))
       {
-	if (permerror (DECL_SOURCE_LOCATION (newdecl),
-		       "friend declaration of %q#D specifies default "
-		       "arguments and isn't the only declaration", newdecl))
-	  inform (DECL_SOURCE_LOCATION (olddecl),
-		  "previous declaration of %q#D", olddecl);
+	diagnostic_group d;
+	if (d.permerror (DECL_SOURCE_LOCATION (newdecl),
+			 "friend declaration of %q#D specifies default "
+			 "arguments and isn't the only declaration", newdecl))
+	  d.inform (DECL_SOURCE_LOCATION (olddecl),
+		    "previous declaration of %q#D", olddecl);
 	return;
       }
 }
@@ -1555,12 +1558,14 @@ next_arg:;
 				    "declaration %q#D", newdecl, olddecl);
 			  return error_mark_node;
 			}
-		      if (permerror (newdecl_loc,
-				     "new declaration %q#D ambiguates built-in"
-				     " declaration %q#D", newdecl, olddecl)
+		      diagnostic_group d;
+		      if (d.permerror (newdecl_loc,
+				       "new declaration %q#D ambiguates "
+				       "built-in declaration %q#D", newdecl,
+				       olddecl)
 			  && flag_permissive)
-			inform (newdecl_loc,
-				"ignoring the %q#D declaration", newdecl);
+			d.inform (newdecl_loc,
+				  "ignoring the %q#D declaration", newdecl);
 		      return flag_permissive ? olddecl : error_mark_node;
 		    }
 		}
@@ -1801,12 +1806,13 @@ next_arg:;
       const char *errmsg = redeclaration_error_message (newdecl, olddecl);
       if (errmsg)
 	{
-	  error_at (newdecl_loc, errmsg, newdecl);
+	  diagnostic_group d;
+	  d.error_at (newdecl_loc, errmsg, newdecl);
 	  if (DECL_NAME (olddecl) != NULL_TREE)
-	    inform (olddecl_loc,
-		    (DECL_INITIAL (olddecl) && namespace_bindings_p ())
-		    ? G_("%q#D previously defined here")
-		    : G_("%q#D previously declared here"), olddecl);
+	    d.inform (olddecl_loc,
+		      (DECL_INITIAL (olddecl) && namespace_bindings_p ())
+		      ? G_("%q#D previously defined here")
+		      : G_("%q#D previously declared here"), olddecl);
 	  return error_mark_node;
 	}
       else if (TREE_CODE (olddecl) == FUNCTION_DECL
@@ -1815,10 +1821,11 @@ next_arg:;
 	       && prototype_p (TREE_TYPE (newdecl)))
 	{
 	  /* Prototype decl follows defn w/o prototype.  */
-	  if (warning_at (newdecl_loc, 0,
-			  "prototype specified for %q#D", newdecl))
-	    inform (olddecl_loc,
-		    "previous non-prototype definition here");
+	  diagnostic_group d;
+	  if (d.warning_at (newdecl_loc, 0,
+			    "prototype specified for %q#D", newdecl))
+	    d.inform (olddecl_loc,
+		      "previous non-prototype definition here");
 	}
       else if (VAR_OR_FUNCTION_DECL_P (olddecl)
 	       && DECL_LANGUAGE (newdecl) != DECL_LANGUAGE (olddecl))
@@ -1856,12 +1863,13 @@ next_arg:;
 	    }
 	  else
 	    {
-	      error_at (newdecl_loc,
-			"conflicting declaration of %q#D with %qL linkage",
-			newdecl, DECL_LANGUAGE (newdecl));
-	      inform (olddecl_loc,
-		      "previous declaration with %qL linkage",
-		      DECL_LANGUAGE (olddecl));
+	      diagnostic_group d;
+	      d.error_at (newdecl_loc,
+			  "conflicting declaration of %q#D with %qL linkage",
+			  newdecl, DECL_LANGUAGE (newdecl));
+	      d.inform (olddecl_loc,
+			"previous declaration with %qL linkage",
+			DECL_LANGUAGE (olddecl));
 	    }
 	}
 
@@ -1893,21 +1901,23 @@ next_arg:;
 		    if (simple_cst_equal (TREE_PURPOSE (t1),
 					  TREE_PURPOSE (t2)) == 1)
 		      {
-			if (permerror (newdecl_loc,
-				       "default argument given for parameter "
-				       "%d of %q#D", i, newdecl))
-			  inform (olddecl_loc,
-				  "previous specification in %q#D here",
-				  olddecl);
+			diagnostic_group d;
+			if (d.permerror (newdecl_loc,
+					 "default argument given for parameter "
+					 "%d of %q#D", i, newdecl))
+			  d.inform (olddecl_loc,
+				    "previous specification in %q#D here",
+				    olddecl);
 		      }
 		    else
 		      {
-			error_at (newdecl_loc,
-				  "default argument given for parameter %d "
-				  "of %q#D", i, newdecl);
-			inform (olddecl_loc,
-				"previous specification in %q#D here",
-				olddecl);
+			diagnostic_group d;
+			d.error_at (newdecl_loc,
+				    "default argument given for parameter %d "
+				    "of %q#D", i, newdecl);
+			d.inform (olddecl_loc,
+				  "previous specification in %q#D here",
+				  olddecl);
 		      }
 		  }
 
@@ -1977,12 +1987,13 @@ next_arg:;
 	  && (! DECL_TEMPLATE_SPECIALIZATION (newdecl)
 	      || DECL_TEMPLATE_SPECIALIZATION (olddecl)))
 	{
-	  if (warning_at (newdecl_loc,
-			  OPT_Wredundant_decls,
-			  "redundant redeclaration of %qD in same scope",
-			  newdecl))
-	    inform (olddecl_loc,
-		    "previous declaration of %qD", olddecl);
+	  diagnostic_group d;
+	  if (d.warning_at (newdecl_loc,
+			    OPT_Wredundant_decls,
+			    "redundant redeclaration of %qD in same scope",
+			    newdecl))
+	    d.inform (olddecl_loc,
+		      "previous declaration of %qD", olddecl);
 	}
 
       if (!(DECL_TEMPLATE_INSTANTIATION (olddecl)
@@ -1990,9 +2001,10 @@ next_arg:;
 	{
 	  if (DECL_DELETED_FN (newdecl))
 	    {
-	      error_at (newdecl_loc, "deleted definition of %qD", newdecl);
-	      inform (olddecl_loc,
-		      "previous declaration of %qD", olddecl);
+	      diagnostic_group d;
+	      d.error_at (newdecl_loc, "deleted definition of %qD", newdecl);
+	      d.inform (olddecl_loc,
+			"previous declaration of %qD", olddecl);
 	    }
 	  DECL_DELETED_FN (newdecl) |= DECL_DELETED_FN (olddecl);
 	}
@@ -2567,11 +2579,12 @@ next_arg:;
       && DECL_VISIBILITY_SPECIFIED (newdecl)
       && DECL_VISIBILITY (newdecl) != DECL_VISIBILITY (olddecl))
     {
-      if (warning_at (newdecl_loc, OPT_Wattributes,
-		      "%qD: visibility attribute ignored because it "
-		      "conflicts with previous declaration", newdecl))
-	inform (olddecl_loc,
-		"previous declaration of %qD", olddecl);
+      diagnostic_group d;
+      if (d.warning_at (newdecl_loc, OPT_Wattributes,
+			"%qD: visibility attribute ignored because it "
+			"conflicts with previous declaration", newdecl))
+	d.inform (olddecl_loc,
+		  "previous declaration of %qD", olddecl);
     }
   /* Choose the declaration which specified visibility.  */
   if (DECL_VISIBILITY_SPECIFIED (olddecl))
@@ -2986,12 +2999,15 @@ redeclaration_error_message (tree newdecl, tree olddecl)
 	{
 	  DECL_EXTERNAL (newdecl) = 1;
 	  /* For now, only warn with explicit -Wdeprecated.  */
-	  if (global_options_set.x_warn_deprecated
-	      && warning_at (DECL_SOURCE_LOCATION (newdecl), OPT_Wdeprecated,
-			     "redundant redeclaration of %<constexpr%> static "
-			     "data member %qD", newdecl))
-	    inform (DECL_SOURCE_LOCATION (olddecl),
-		    "previous declaration of %qD", olddecl);
+	  if (global_options_set.x_warn_deprecated)
+	    {
+	      diagnostic_group d;
+	      if (d.warning_at (DECL_SOURCE_LOCATION (newdecl), OPT_Wdeprecated,
+				"redundant redeclaration of %<constexpr%> "
+				"static data member %qD", newdecl))
+		d.inform (DECL_SOURCE_LOCATION (olddecl),
+			  "previous declaration of %qD", olddecl);
+	    }
 	  return NULL;
 	}
 
@@ -4752,12 +4768,13 @@ warn_misplaced_attr_for_class_type (source_location location,
 {
   gcc_assert (OVERLOAD_TYPE_P (class_type));
 
-  if (warning_at (location, OPT_Wattributes,
-		  "attribute ignored in declaration "
-		  "of %q#T", class_type))
-    inform (location,
-	    "attribute for %q#T must follow the %qs keyword",
-	    class_type, class_key_or_enum_as_string (class_type));
+  diagnostic_group d;
+  if (d.warning_at (location, OPT_Wattributes,
+		    "attribute ignored in declaration "
+		    "of %q#T", class_type))
+    d.inform (location,
+	      "attribute for %q#T must follow the %qs keyword",
+	      class_type, class_key_or_enum_as_string (class_type));
 }
 
 /* Make sure that a declaration with no declarator is well-formed, i.e.
